/* baobab-scanner.c generated by valac 0.40.10, the Vala compiler
 * generated from baobab-scanner.vala, do not modify */

/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Baobab - disk usage analyzer
 *
 * Copyright (C) 2012  Ryan Lortie <desrt@desrt.ca>
 * Copyright (C) 2012  Paolo Borelli <pborelli@gnome.org>
 * Copyright (C) 2012  Stefano Facchini <stefano.facchini@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gio/gunixmounts.h>


#define BAOBAB_TYPE_SCAN_FLAGS (baobab_scan_flags_get_type ())

#define BAOBAB_TYPE_SCANNER (baobab_scanner_get_type ())
#define BAOBAB_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BAOBAB_TYPE_SCANNER, BaobabScanner))
#define BAOBAB_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BAOBAB_TYPE_SCANNER, BaobabScannerClass))
#define BAOBAB_IS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BAOBAB_TYPE_SCANNER))
#define BAOBAB_IS_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BAOBAB_TYPE_SCANNER))
#define BAOBAB_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BAOBAB_TYPE_SCANNER, BaobabScannerClass))

typedef struct _BaobabScanner BaobabScanner;
typedef struct _BaobabScannerClass BaobabScannerClass;
typedef struct _BaobabScannerPrivate BaobabScannerPrivate;

#define BAOBAB_SCANNER_TYPE_HARD_LINK (baobab_scanner_hard_link_get_type ())
typedef struct _BaobabScannerHardLink BaobabScannerHardLink;
typedef struct _BaobabScannerResultsArray BaobabScannerResultsArray;
enum  {
	BAOBAB_SCANNER_0_PROPERTY,
	BAOBAB_SCANNER_DIRECTORY_PROPERTY,
	BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY,
	BAOBAB_SCANNER_MAX_DEPTH_PROPERTY,
	BAOBAB_SCANNER_NUM_PROPERTIES
};
static GParamSpec* baobab_scanner_properties[BAOBAB_SCANNER_NUM_PROPERTIES];

#define BAOBAB_SCANNER_TYPE_COLUMNS (baobab_scanner_columns_get_type ())

#define BAOBAB_SCANNER_TYPE_STATE (baobab_scanner_state_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_async_queue_unref0(var) ((var == NULL) ? NULL : (var = (g_async_queue_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BaobabScannerResults BaobabScannerResults;
#define _baobab_scanner_results_array_free0(var) ((var == NULL) ? NULL : (var = (baobab_scanner_results_array_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _baobab_scanner_results_free0(var) ((var == NULL) ? NULL : (var = (baobab_scanner_results_free (var), NULL)))

#define BAOBAB_TYPE_APPLICATION (baobab_application_get_type ())
#define BAOBAB_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BAOBAB_TYPE_APPLICATION, BaobabApplication))
#define BAOBAB_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BAOBAB_TYPE_APPLICATION, BaobabApplicationClass))
#define BAOBAB_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BAOBAB_TYPE_APPLICATION))
#define BAOBAB_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BAOBAB_TYPE_APPLICATION))
#define BAOBAB_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BAOBAB_TYPE_APPLICATION, BaobabApplicationClass))

typedef struct _BaobabApplication BaobabApplication;
typedef struct _BaobabApplicationClass BaobabApplicationClass;
enum  {
	BAOBAB_SCANNER_COMPLETED_SIGNAL,
	BAOBAB_SCANNER_NUM_SIGNALS
};
static guint baobab_scanner_signals[BAOBAB_SCANNER_NUM_SIGNALS] = {0};

typedef enum  {
	BAOBAB_SCAN_FLAGS_NONE = 1 << 0,
	BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS = 1 << 1
} BaobabScanFlags;

struct _BaobabScanner {
	GtkTreeStore parent_instance;
	BaobabScannerPrivate * priv;
};

struct _BaobabScannerClass {
	GtkTreeStoreClass parent_class;
};

struct _BaobabScannerHardLink {
	guint64 inode;
	guint32 device;
};

struct _BaobabScannerPrivate {
	GFile* _directory;
	BaobabScanFlags _scan_flags;
	gint _max_depth;
	GThread* thread;
	guint process_result_idle;
	BaobabScannerHardLink* hardlinks;
	gint hardlinks_length1;
	gint _hardlinks_size_;
	GHashTable* excluded_locations;
	gboolean successful;
	GAsyncQueue* results_queue;
	BaobabScanner* self;
	GCancellable* cancellable;
	GError* scan_error;
};

typedef enum  {
	BAOBAB_SCANNER_COLUMNS_DISPLAY_NAME,
	BAOBAB_SCANNER_COLUMNS_PARSE_NAME,
	BAOBAB_SCANNER_COLUMNS_PERCENT,
	BAOBAB_SCANNER_COLUMNS_SIZE,
	BAOBAB_SCANNER_COLUMNS_ALLOC_SIZE,
	BAOBAB_SCANNER_COLUMNS_TIME_MODIFIED,
	BAOBAB_SCANNER_COLUMNS_ELEMENTS,
	BAOBAB_SCANNER_COLUMNS_STATE,
	BAOBAB_SCANNER_COLUMNS_ERROR,
	BAOBAB_SCANNER_COLUMNS_COLUMNS
} BaobabScannerColumns;

typedef enum  {
	BAOBAB_SCANNER_STATE_SCANNING,
	BAOBAB_SCANNER_STATE_CANCELLED,
	BAOBAB_SCANNER_STATE_NEED_PERCENT,
	BAOBAB_SCANNER_STATE_ERROR,
	BAOBAB_SCANNER_STATE_CHILD_ERROR,
	BAOBAB_SCANNER_STATE_DONE
} BaobabScannerState;

struct _BaobabScannerResults {
	BaobabScannerResults* parent;
	gchar* display_name;
	gchar* parse_name;
	guint64 size;
	guint64 alloc_size;
	guint64 time_modified;
	gint elements;
	gdouble percent;
	gint max_depth;
	GError* error;
	gboolean child_error;
	GtkTreeIter iter;
	gboolean iter_is_set;
};

struct _BaobabScannerResultsArray {
	BaobabScannerResults** results;
	gint results_length1;
	gint _results_size_;
};


static gpointer baobab_scanner_parent_class = NULL;

GType baobab_scan_flags_get_type (void) G_GNUC_CONST;
GType baobab_scanner_get_type (void) G_GNUC_CONST;
static GType baobab_scanner_hard_link_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static BaobabScannerHardLink* baobab_scanner_hard_link_dup (const BaobabScannerHardLink* self);
static void baobab_scanner_hard_link_free (BaobabScannerHardLink* self);
static void baobab_scanner_results_array_free (BaobabScannerResultsArray * self);
#define BAOBAB_SCANNER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BAOBAB_TYPE_SCANNER, BaobabScannerPrivate))
GType baobab_scanner_columns_get_type (void) G_GNUC_CONST;
GType baobab_scanner_state_get_type (void) G_GNUC_CONST;
#define BAOBAB_SCANNER_ATTRIBUTES G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE "," G_FILE_ATTRIBUTE_TIME_MODIFIED "," G_FILE_ATTRIBUTE_UNIX_NLINK "," G_FILE_ATTRIBUTE_UNIX_INODE "," G_FILE_ATTRIBUTE_UNIX_DEVICE "," G_FILE_ATTRIBUTE_ACCESS_CAN_READ
static void baobab_scanner_results_free (BaobabScannerResults * self);
static BaobabScannerResults* baobab_scanner_add_directory (BaobabScanner* self,
                                                    GFile* directory,
                                                    GFileInfo* info,
                                                    BaobabScannerResults* parent);
static BaobabScannerResultsArray* baobab_scanner_results_array_new (void);
static BaobabScannerResults* baobab_scanner_results_new (void);
static void _vala_array_add1 (BaobabScannerResults** * array,
                       int* length,
                       int* size,
                       BaobabScannerResults* value);
static void baobab_scanner_hard_link_init (BaobabScannerHardLink *self,
                                    GFileInfo* info);
static gboolean _baobab_scanner_hard_link_equal (const BaobabScannerHardLink * s1,
                                          const BaobabScannerHardLink * s2);
static gboolean _vala_baobab_scanner_hard_link_array_contains (BaobabScannerHardLink * stack,
                                                        int stack_length,
                                                        BaobabScannerHardLink * needle);
static void _vala_array_add2 (BaobabScannerHardLink* * array,
                       int* length,
                       int* size,
                       const BaobabScannerHardLink* value);
static void* baobab_scanner_scan_in_thread (BaobabScanner* self);
GFile* baobab_scanner_get_directory (BaobabScanner* self);
static void _vala_array_add3 (BaobabScannerResults** * array,
                       int* length,
                       int* size,
                       BaobabScannerResults* value);
static void baobab_scanner_ensure_iter_exists (BaobabScanner* self,
                                        BaobabScannerResults* results);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static gboolean baobab_scanner_process_results (BaobabScanner* self);
gint baobab_scanner_get_max_depth (BaobabScanner* self);
void baobab_scanner_set_max_depth (BaobabScanner* self,
                                   gint value);
static void baobab_scanner_cancel_and_reset (BaobabScanner* self);
void baobab_scanner_scan (BaobabScanner* self,
                          gboolean force);
static gpointer _baobab_scanner_scan_in_thread_gthread_func (gpointer self);
static gboolean ___lambda4_ (BaobabScanner* self);
static gboolean ____lambda4__gsource_func (gpointer self);
void baobab_scanner_cancel (BaobabScanner* self);
void baobab_scanner_finish (BaobabScanner* self,
                            GError** error);
BaobabScanner* baobab_scanner_new (GFile* directory,
                                   BaobabScanFlags flags);
BaobabScanner* baobab_scanner_construct (GType object_type,
                                         GFile* directory,
                                         BaobabScanFlags flags);
static void baobab_scanner_set_directory (BaobabScanner* self,
                                   GFile* value);
static void baobab_scanner_set_scan_flags (BaobabScanner* self,
                                    BaobabScanFlags value);
GType baobab_application_get_type (void) G_GNUC_CONST;
BaobabApplication* baobab_application_get_default (void);
GHashTable* baobab_application_get_excluded_locations (BaobabApplication* self);
static void _g_unix_mount_free0_ (gpointer var);
static inline void _g_list_free__g_unix_mount_free0_ (GList* self);
static void _baobab_scanner_results_array_free0_ (gpointer var);
BaobabScanFlags baobab_scanner_get_scan_flags (BaobabScanner* self);
static void baobab_scanner_results_array_instance_init (BaobabScannerResultsArray * self);
static void baobab_scanner_results_instance_init (BaobabScannerResults * self);
static void baobab_scanner_finalize (GObject * obj);
static void _vala_baobab_scanner_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_baobab_scanner_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


GType
baobab_scan_flags_get_type (void)
{
	static volatile gsize baobab_scan_flags_type_id__volatile = 0;
	if (g_once_init_enter (&baobab_scan_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{BAOBAB_SCAN_FLAGS_NONE, "BAOBAB_SCAN_FLAGS_NONE", "none"}, {BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS, "BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS", "exclude-mounts"}, {0, NULL, NULL}};
		GType baobab_scan_flags_type_id;
		baobab_scan_flags_type_id = g_flags_register_static ("BaobabScanFlags", values);
		g_once_init_leave (&baobab_scan_flags_type_id__volatile, baobab_scan_flags_type_id);
	}
	return baobab_scan_flags_type_id__volatile;
}


GType
baobab_scanner_columns_get_type (void)
{
	static volatile gsize baobab_scanner_columns_type_id__volatile = 0;
	if (g_once_init_enter (&baobab_scanner_columns_type_id__volatile)) {
		static const GEnumValue values[] = {{BAOBAB_SCANNER_COLUMNS_DISPLAY_NAME, "BAOBAB_SCANNER_COLUMNS_DISPLAY_NAME", "display-name"}, {BAOBAB_SCANNER_COLUMNS_PARSE_NAME, "BAOBAB_SCANNER_COLUMNS_PARSE_NAME", "parse-name"}, {BAOBAB_SCANNER_COLUMNS_PERCENT, "BAOBAB_SCANNER_COLUMNS_PERCENT", "percent"}, {BAOBAB_SCANNER_COLUMNS_SIZE, "BAOBAB_SCANNER_COLUMNS_SIZE", "size"}, {BAOBAB_SCANNER_COLUMNS_ALLOC_SIZE, "BAOBAB_SCANNER_COLUMNS_ALLOC_SIZE", "alloc-size"}, {BAOBAB_SCANNER_COLUMNS_TIME_MODIFIED, "BAOBAB_SCANNER_COLUMNS_TIME_MODIFIED", "time-modified"}, {BAOBAB_SCANNER_COLUMNS_ELEMENTS, "BAOBAB_SCANNER_COLUMNS_ELEMENTS", "elements"}, {BAOBAB_SCANNER_COLUMNS_STATE, "BAOBAB_SCANNER_COLUMNS_STATE", "state"}, {BAOBAB_SCANNER_COLUMNS_ERROR, "BAOBAB_SCANNER_COLUMNS_ERROR", "error"}, {BAOBAB_SCANNER_COLUMNS_COLUMNS, "BAOBAB_SCANNER_COLUMNS_COLUMNS", "columns"}, {0, NULL, NULL}};
		GType baobab_scanner_columns_type_id;
		baobab_scanner_columns_type_id = g_enum_register_static ("BaobabScannerColumns", values);
		g_once_init_leave (&baobab_scanner_columns_type_id__volatile, baobab_scanner_columns_type_id);
	}
	return baobab_scanner_columns_type_id__volatile;
}


GType
baobab_scanner_state_get_type (void)
{
	static volatile gsize baobab_scanner_state_type_id__volatile = 0;
	if (g_once_init_enter (&baobab_scanner_state_type_id__volatile)) {
		static const GEnumValue values[] = {{BAOBAB_SCANNER_STATE_SCANNING, "BAOBAB_SCANNER_STATE_SCANNING", "scanning"}, {BAOBAB_SCANNER_STATE_CANCELLED, "BAOBAB_SCANNER_STATE_CANCELLED", "cancelled"}, {BAOBAB_SCANNER_STATE_NEED_PERCENT, "BAOBAB_SCANNER_STATE_NEED_PERCENT", "need-percent"}, {BAOBAB_SCANNER_STATE_ERROR, "BAOBAB_SCANNER_STATE_ERROR", "error"}, {BAOBAB_SCANNER_STATE_CHILD_ERROR, "BAOBAB_SCANNER_STATE_CHILD_ERROR", "child-error"}, {BAOBAB_SCANNER_STATE_DONE, "BAOBAB_SCANNER_STATE_DONE", "done"}, {0, NULL, NULL}};
		GType baobab_scanner_state_type_id;
		baobab_scanner_state_type_id = g_enum_register_static ("BaobabScannerState", values);
		g_once_init_leave (&baobab_scanner_state_type_id__volatile, baobab_scanner_state_type_id);
	}
	return baobab_scanner_state_type_id__volatile;
}


static void
_vala_array_add1 (BaobabScannerResults** * array,
                  int* length,
                  int* size,
                  BaobabScannerResults* value)
{
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 318 "baobab-scanner.c"
	}
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 324 "baobab-scanner.c"
}


static gboolean
_baobab_scanner_hard_link_equal (const BaobabScannerHardLink * s1,
                                 const BaobabScannerHardLink * s2)
{
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (s1 == s2) {
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return TRUE;
#line 336 "baobab-scanner.c"
	}
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (s1 == NULL) {
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return FALSE;
#line 342 "baobab-scanner.c"
	}
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (s2 == NULL) {
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return FALSE;
#line 348 "baobab-scanner.c"
	}
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (s1->inode != s2->inode) {
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return FALSE;
#line 354 "baobab-scanner.c"
	}
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (s1->device != s2->device) {
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return FALSE;
#line 360 "baobab-scanner.c"
	}
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return TRUE;
#line 364 "baobab-scanner.c"
}


static gboolean
_vala_baobab_scanner_hard_link_array_contains (BaobabScannerHardLink * stack,
                                               int stack_length,
                                               BaobabScannerHardLink * needle)
{
	int i;
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	for (i = 0; i < stack_length; i++) {
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		if (_baobab_scanner_hard_link_equal (&stack[i], needle) == TRUE) {
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			return TRUE;
#line 380 "baobab-scanner.c"
		}
	}
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return FALSE;
#line 385 "baobab-scanner.c"
}


static void
_vala_array_add2 (BaobabScannerHardLink* * array,
                  int* length,
                  int* size,
                  const BaobabScannerHardLink* value)
{
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerHardLink, *array, *size);
#line 401 "baobab-scanner.c"
	}
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(*array)[(*length)++] = *value;
#line 405 "baobab-scanner.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 242 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return self ? g_error_copy (self) : NULL;
#line 414 "baobab-scanner.c"
}


static BaobabScannerResults*
baobab_scanner_add_directory (BaobabScanner* self,
                              GFile* directory,
                              GFileInfo* info,
                              BaobabScannerResults* parent)
{
	BaobabScannerResults* result = NULL;
	BaobabScannerResultsArray* results_array = NULL;
	BaobabScannerResultsArray* _tmp0_;
	GHashTable* _tmp1_;
	BaobabScannerResults* results = NULL;
	BaobabScannerResults* _tmp2_;
	BaobabScannerResults* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	BaobabScannerResults* _tmp6_;
	gchar* _tmp7_;
	BaobabScannerResults* _tmp8_;
	BaobabScannerResults* _tmp9_;
	BaobabScannerResults* _tmp10_;
	BaobabScannerResults* _tmp12_;
	BaobabScannerResults* _tmp13_;
	BaobabScannerResults* _tmp14_;
	BaobabScannerResultsArray* _tmp96_;
	BaobabScannerResults** _tmp97_;
	gint _tmp97__length1;
	GAsyncQueue* _tmp106_;
	BaobabScannerResultsArray* _tmp107_;
	GError * _inner_error_ = NULL;
#line 162 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 162 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 162 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 163 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = baobab_scanner_results_array_new ();
#line 163 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	results_array = _tmp0_;
#line 165 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_ = self->priv->excluded_locations;
#line 165 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (g_hash_table_contains (_tmp1_, directory)) {
#line 166 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		result = NULL;
#line 166 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 166 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return result;
#line 467 "baobab-scanner.c"
	}
#line 169 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp2_ = baobab_scanner_results_new ();
#line 169 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	results = _tmp2_;
#line 170 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp3_ = results;
#line 170 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp4_ = g_file_info_get_display_name (info);
#line 170 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 170 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_free0 (_tmp3_->display_name);
#line 170 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp3_->display_name = _tmp5_;
#line 171 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp6_ = results;
#line 171 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp7_ = g_file_get_parse_name (directory);
#line 171 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_free0 (_tmp6_->parse_name);
#line 171 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp6_->parse_name = _tmp7_;
#line 172 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp8_ = results;
#line 172 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp8_->parent = parent;
#line 174 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp9_ = results;
#line 174 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp9_->time_modified = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 176 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp10_ = results;
#line 176 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp10_->size = (guint64) g_file_info_get_size (info);
#line 177 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (g_file_info_has_attribute (info, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE)) {
#line 505 "baobab-scanner.c"
		BaobabScannerResults* _tmp11_;
#line 178 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp11_ = results;
#line 178 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp11_->alloc_size = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE);
#line 511 "baobab-scanner.c"
	}
#line 180 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp12_ = results;
#line 180 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp12_->elements = 1;
#line 181 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp13_ = results;
#line 181 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_error_free0 (_tmp13_->error);
#line 181 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp13_->error = NULL;
#line 182 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp14_ = results;
#line 182 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp14_->child_error = FALSE;
#line 527 "baobab-scanner.c"
	{
		GFileEnumerator* children = NULL;
		GCancellable* _tmp15_;
		GFileEnumerator* _tmp16_;
		GFileInfo* child_info = NULL;
#line 185 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp15_ = self->priv->cancellable;
#line 185 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp16_ = g_file_enumerate_children (directory, BAOBAB_SCANNER_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, _tmp15_, &_inner_error_);
#line 185 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		children = _tmp16_;
#line 185 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 541 "baobab-scanner.c"
			goto __catch4_g_error;
		}
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		while (TRUE) {
#line 546 "baobab-scanner.c"
			GFileInfo* _tmp17_ = NULL;
			GFileEnumerator* _tmp18_;
			GCancellable* _tmp19_;
			GFileInfo* _tmp20_;
			GFileInfo* _tmp21_;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp18_ = children;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp19_ = self->priv->cancellable;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp20_ = g_file_enumerator_next_file (_tmp18_, _tmp19_, &_inner_error_);
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp17_ = _tmp20_;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				_g_object_unref0 (child_info);
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				_g_object_unref0 (children);
#line 568 "baobab-scanner.c"
				goto __catch4_g_error;
			}
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp21_ = _tmp17_;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp17_ = NULL;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_g_object_unref0 (child_info);
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			child_info = _tmp21_;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp22_ = child_info;
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			if (!(_tmp22_ != NULL)) {
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				_g_object_unref0 (_tmp17_);
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				break;
#line 587 "baobab-scanner.c"
			}
#line 188 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_tmp23_ = child_info;
#line 188 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			switch (g_file_info_get_file_type (_tmp23_)) {
#line 188 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				case G_FILE_TYPE_DIRECTORY:
#line 595 "baobab-scanner.c"
				{
					GFile* child = NULL;
					GFileInfo* _tmp24_;
					const gchar* _tmp25_;
					GFile* _tmp26_;
					BaobabScannerResults* child_results = NULL;
					GFile* _tmp27_;
					GFileInfo* _tmp28_;
					BaobabScannerResults* _tmp29_;
					BaobabScannerResults* _tmp30_;
					BaobabScannerResults* _tmp31_;
#line 190 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp24_ = child_info;
#line 190 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp25_ = g_file_info_get_name (_tmp24_);
#line 190 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp26_ = g_file_get_child (directory, _tmp25_);
#line 190 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					child = _tmp26_;
#line 191 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp27_ = child;
#line 191 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp28_ = child_info;
#line 191 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp29_ = results;
#line 191 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp30_ = baobab_scanner_add_directory (self, _tmp27_, _tmp28_, _tmp29_);
#line 191 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					child_results = _tmp30_;
#line 193 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp31_ = child_results;
#line 193 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (_tmp31_ != NULL) {
#line 629 "baobab-scanner.c"
						BaobabScannerResults* _tmp32_;
						BaobabScannerResults* _tmp33_;
						guint64 _tmp34_;
						BaobabScannerResults* _tmp35_;
						guint64 _tmp36_;
						BaobabScannerResults* _tmp37_;
						BaobabScannerResults* _tmp38_;
						guint64 _tmp39_;
						BaobabScannerResults* _tmp40_;
						guint64 _tmp41_;
						BaobabScannerResults* _tmp42_;
						BaobabScannerResults* _tmp43_;
						gint _tmp44_;
						BaobabScannerResults* _tmp45_;
						gint _tmp46_;
						BaobabScannerResults* _tmp47_;
						BaobabScannerResults* _tmp48_;
						gint _tmp49_;
						BaobabScannerResults* _tmp50_;
						gint _tmp51_;
						gboolean _tmp52_ = FALSE;
						BaobabScannerResults* _tmp53_;
						GError* _tmp54_;
						BaobabScannerResults* _tmp58_;
						guint64 _tmp59_;
						BaobabScannerResults* _tmp60_;
						guint64 _tmp61_;
						BaobabScannerResultsArray* _tmp65_;
						BaobabScannerResultsArray* _tmp66_;
						BaobabScannerResults** _tmp67_;
						gint _tmp67__length1;
						BaobabScannerResults* _tmp68_;
#line 194 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp32_ = results;
#line 194 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp33_ = results;
#line 194 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp34_ = _tmp33_->size;
#line 194 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp35_ = child_results;
#line 194 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp36_ = _tmp35_->size;
#line 194 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp33_->size = _tmp34_ + _tmp36_;
#line 195 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp37_ = results;
#line 195 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp38_ = results;
#line 195 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp39_ = _tmp38_->alloc_size;
#line 195 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp40_ = child_results;
#line 195 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp41_ = _tmp40_->alloc_size;
#line 195 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp38_->alloc_size = _tmp39_ + _tmp41_;
#line 196 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp42_ = results;
#line 196 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp43_ = results;
#line 196 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp44_ = _tmp43_->elements;
#line 196 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp45_ = child_results;
#line 196 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp46_ = _tmp45_->elements;
#line 196 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp43_->elements = _tmp44_ + _tmp46_;
#line 197 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp47_ = results;
#line 197 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp48_ = results;
#line 197 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp49_ = _tmp48_->max_depth;
#line 197 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp50_ = child_results;
#line 197 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp51_ = _tmp50_->max_depth;
#line 197 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp47_->max_depth = MAX (_tmp49_, _tmp51_ + 1);
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp53_ = child_results;
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp54_ = _tmp53_->error;
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						if (_tmp54_ != NULL) {
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp52_ = TRUE;
#line 718 "baobab-scanner.c"
						} else {
							BaobabScannerResults* _tmp55_;
							gboolean _tmp56_;
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp55_ = child_results;
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp56_ = _tmp55_->child_error;
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp52_ = _tmp56_;
#line 728 "baobab-scanner.c"
						}
#line 198 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						if (_tmp52_) {
#line 732 "baobab-scanner.c"
							BaobabScannerResults* _tmp57_;
#line 199 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp57_ = results;
#line 199 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp57_->child_error = TRUE;
#line 738 "baobab-scanner.c"
						}
#line 202 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp58_ = results;
#line 202 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp59_ = _tmp58_->time_modified;
#line 202 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp60_ = child_results;
#line 202 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp61_ = _tmp60_->time_modified;
#line 202 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						if (_tmp59_ < _tmp61_) {
#line 750 "baobab-scanner.c"
							BaobabScannerResults* _tmp62_;
							BaobabScannerResults* _tmp63_;
							guint64 _tmp64_;
#line 203 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp62_ = results;
#line 203 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp63_ = child_results;
#line 203 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp64_ = _tmp63_->time_modified;
#line 203 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp62_->time_modified = _tmp64_;
#line 762 "baobab-scanner.c"
						}
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp65_ = results_array;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp66_ = results_array;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp67_ = _tmp66_->results;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp67__length1 = _tmp66_->results_length1;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp68_ = child_results;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						child_results = NULL;
#line 206 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_vala_array_add1 (&_tmp65_->results, &_tmp65_->results_length1, &_tmp65_->_results_size_, _tmp68_);
#line 778 "baobab-scanner.c"
					}
#line 208 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_baobab_scanner_results_free0 (child_results);
#line 208 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_g_object_unref0 (child);
#line 208 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					break;
#line 786 "baobab-scanner.c"
				}
#line 188 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				case G_FILE_TYPE_REGULAR:
#line 790 "baobab-scanner.c"
				{
					GFileInfo* _tmp69_;
					BaobabScannerResults* _tmp76_;
					BaobabScannerResults* _tmp77_;
					guint64 _tmp78_;
					GFileInfo* _tmp79_;
					GFileInfo* _tmp80_;
					BaobabScannerResults* _tmp85_;
					gint _tmp86_;
					guint64 child_time = 0ULL;
					GFileInfo* _tmp87_;
					BaobabScannerResults* _tmp88_;
					guint64 _tmp89_;
					guint64 _tmp90_;
#line 211 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp69_ = child_info;
#line 211 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (g_file_info_has_attribute (_tmp69_, G_FILE_ATTRIBUTE_UNIX_NLINK)) {
#line 809 "baobab-scanner.c"
						GFileInfo* _tmp70_;
#line 212 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp70_ = child_info;
#line 212 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						if (g_file_info_get_attribute_uint32 (_tmp70_, G_FILE_ATTRIBUTE_UNIX_NLINK) > ((guint32) 1)) {
#line 815 "baobab-scanner.c"
							BaobabScannerHardLink hl = {0};
							GFileInfo* _tmp71_;
							BaobabScannerHardLink _tmp72_;
							BaobabScannerHardLink* _tmp73_;
							gint _tmp73__length1;
							BaobabScannerHardLink* _tmp74_;
							gint _tmp74__length1;
							BaobabScannerHardLink _tmp75_;
#line 213 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp71_ = child_info;
#line 213 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							baobab_scanner_hard_link_init (&hl, _tmp71_);
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp72_ = hl;
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp73_ = self->priv->hardlinks;
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp73__length1 = self->priv->hardlinks_length1;
#line 216 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							if (_vala_baobab_scanner_hard_link_array_contains (_tmp73_, _tmp73__length1, &_tmp72_)) {
#line 217 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
								continue;
#line 838 "baobab-scanner.c"
							}
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp74_ = self->priv->hardlinks;
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp74__length1 = self->priv->hardlinks_length1;
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp75_ = hl;
#line 220 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_vala_array_add2 (&self->priv->hardlinks, &self->priv->hardlinks_length1, &self->priv->_hardlinks_size_, &_tmp75_);
#line 848 "baobab-scanner.c"
						}
					}
#line 224 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp76_ = results;
#line 224 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp77_ = results;
#line 224 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp78_ = _tmp77_->size;
#line 224 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp79_ = child_info;
#line 224 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp77_->size = _tmp78_ + g_file_info_get_size (_tmp79_);
#line 225 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp80_ = child_info;
#line 225 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (g_file_info_has_attribute (_tmp80_, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE)) {
#line 865 "baobab-scanner.c"
						BaobabScannerResults* _tmp81_;
						BaobabScannerResults* _tmp82_;
						guint64 _tmp83_;
						GFileInfo* _tmp84_;
#line 226 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp81_ = results;
#line 226 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp82_ = results;
#line 226 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp83_ = _tmp82_->alloc_size;
#line 226 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp84_ = child_info;
#line 226 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp82_->alloc_size = _tmp83_ + g_file_info_get_attribute_uint64 (_tmp84_, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE);
#line 880 "baobab-scanner.c"
					}
#line 228 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp85_ = results;
#line 228 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp86_ = _tmp85_->elements;
#line 228 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp85_->elements = _tmp86_ + 1;
#line 230 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp87_ = child_info;
#line 230 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					child_time = g_file_info_get_attribute_uint64 (_tmp87_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 231 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp88_ = results;
#line 231 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp89_ = _tmp88_->time_modified;
#line 231 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp90_ = child_time;
#line 231 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (_tmp89_ < _tmp90_) {
#line 900 "baobab-scanner.c"
						BaobabScannerResults* _tmp91_;
						guint64 _tmp92_;
#line 232 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp91_ = results;
#line 232 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp92_ = child_time;
#line 232 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp91_->time_modified = _tmp92_;
#line 909 "baobab-scanner.c"
					}
#line 234 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					break;
#line 913 "baobab-scanner.c"
				}
				default:
				{
#line 238 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					break;
#line 919 "baobab-scanner.c"
				}
			}
#line 187 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_g_object_unref0 (_tmp17_);
#line 924 "baobab-scanner.c"
		}
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_object_unref0 (child_info);
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_object_unref0 (children);
#line 930 "baobab-scanner.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		BaobabScannerResults* _tmp93_;
		GError* _tmp94_;
		GError* _tmp95_;
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		e = _inner_error_;
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_inner_error_ = NULL;
#line 242 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp93_ = results;
#line 242 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp94_ = e;
#line 242 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp95_ = _g_error_copy0 (_tmp94_);
#line 242 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_error_free0 (_tmp93_->error);
#line 242 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp93_->error = _tmp95_;
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_error_free0 (e);
#line 955 "baobab-scanner.c"
	}
	__finally4:
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_baobab_scanner_results_free0 (results);
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_clear_error (&_inner_error_);
#line 184 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return NULL;
#line 970 "baobab-scanner.c"
	}
#line 245 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp96_ = results_array;
#line 245 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp97_ = _tmp96_->results;
#line 245 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp97__length1 = _tmp96_->results_length1;
#line 978 "baobab-scanner.c"
	{
		BaobabScannerResults** child_results_collection = NULL;
		gint child_results_collection_length1 = 0;
		gint _child_results_collection_size_ = 0;
		gint child_results_it = 0;
#line 245 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		child_results_collection = _tmp97_;
#line 245 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		child_results_collection_length1 = _tmp97__length1;
#line 245 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		for (child_results_it = 0; child_results_it < _tmp97__length1; child_results_it = child_results_it + 1) {
#line 990 "baobab-scanner.c"
			BaobabScannerResults* child_results = NULL;
#line 245 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			child_results = child_results_collection[child_results_it];
#line 994 "baobab-scanner.c"
			{
				BaobabScannerResults* _tmp98_;
				guint64 _tmp99_;
#line 246 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				_tmp98_ = results;
#line 246 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				_tmp99_ = _tmp98_->size;
#line 246 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				if (_tmp99_ > ((guint64) 0)) {
#line 1004 "baobab-scanner.c"
					BaobabScannerResults* _tmp100_;
					BaobabScannerResults* _tmp101_;
					guint64 _tmp102_;
					BaobabScannerResults* _tmp103_;
					guint64 _tmp104_;
#line 247 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp100_ = child_results;
#line 247 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp101_ = child_results;
#line 247 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp102_ = _tmp101_->size;
#line 247 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp103_ = results;
#line 247 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp104_ = _tmp103_->size;
#line 247 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp100_->percent = (100 * ((gdouble) _tmp102_)) / ((gdouble) _tmp104_);
#line 1022 "baobab-scanner.c"
				} else {
					BaobabScannerResults* _tmp105_;
#line 249 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp105_ = child_results;
#line 249 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp105_->percent = (gdouble) 0;
#line 1029 "baobab-scanner.c"
				}
			}
		}
	}
#line 256 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp106_ = self->priv->results_queue;
#line 256 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp107_ = results_array;
#line 256 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	results_array = NULL;
#line 256 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_async_queue_push (_tmp106_, _tmp107_);
#line 258 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	result = results;
#line 258 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_baobab_scanner_results_array_free0 (results_array);
#line 258 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 1048 "baobab-scanner.c"
}


static void
_vala_array_add3 (BaobabScannerResults** * array,
                  int* length,
                  int* size,
                  BaobabScannerResults* value)
{
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 1064 "baobab-scanner.c"
	}
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 1070 "baobab-scanner.c"
}


static void*
baobab_scanner_scan_in_thread (BaobabScanner* self)
{
	void* result = NULL;
	GError * _inner_error_ = NULL;
#line 261 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1081 "baobab-scanner.c"
	{
		BaobabScannerResultsArray* array = NULL;
		BaobabScannerResultsArray* _tmp0_;
		GFileInfo* info = NULL;
		GFile* _tmp1_;
		GCancellable* _tmp2_;
		GFileInfo* _tmp3_;
		BaobabScannerResults* results = NULL;
		GFile* _tmp4_;
		BaobabScannerResults* _tmp5_;
		BaobabScannerResults* _tmp6_;
		BaobabScannerResultsArray* _tmp7_;
		BaobabScannerResultsArray* _tmp8_;
		BaobabScannerResults** _tmp9_;
		gint _tmp9__length1;
		BaobabScannerResults* _tmp10_;
		GAsyncQueue* _tmp11_;
		BaobabScannerResultsArray* _tmp12_;
#line 263 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp0_ = baobab_scanner_results_array_new ();
#line 263 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		array = _tmp0_;
#line 264 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp1_ = self->priv->_directory;
#line 264 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp2_ = self->priv->cancellable;
#line 264 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp3_ = g_file_query_info (_tmp1_, BAOBAB_SCANNER_ATTRIBUTES, 0, _tmp2_, &_inner_error_);
#line 264 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		info = _tmp3_;
#line 264 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 264 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_baobab_scanner_results_array_free0 (array);
#line 1116 "baobab-scanner.c"
			goto __catch5_g_error;
		}
#line 265 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp4_ = self->priv->_directory;
#line 265 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp5_ = baobab_scanner_add_directory (self, _tmp4_, info, NULL);
#line 265 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		results = _tmp5_;
#line 266 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp6_ = results;
#line 266 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp6_->percent = 100.0;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp7_ = array;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp8_ = array;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp9_ = _tmp8_->results;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp9__length1 = _tmp8_->results_length1;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp10_ = results;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		results = NULL;
#line 267 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_vala_array_add3 (&_tmp7_->results, &_tmp7_->results_length1, &_tmp7_->_results_size_, _tmp10_);
#line 268 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp11_ = self->priv->results_queue;
#line 268 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp12_ = array;
#line 268 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		array = NULL;
#line 268 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_async_queue_push (_tmp11_, _tmp12_);
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_baobab_scanner_results_free0 (results);
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_object_unref0 (info);
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (array);
#line 1157 "baobab-scanner.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		e = _inner_error_;
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_inner_error_ = NULL;
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_error_free0 (e);
#line 1169 "baobab-scanner.c"
	}
	__finally5:
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_clear_error (&_inner_error_);
#line 262 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return NULL;
#line 1180 "baobab-scanner.c"
	}
#line 273 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->self);
#line 273 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->self = NULL;
#line 274 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	result = NULL;
#line 274 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 1190 "baobab-scanner.c"
}


static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	dup = g_new0 (GtkTreeIter, 1);
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	memcpy (dup, self, sizeof (GtkTreeIter));
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return dup;
#line 1204 "baobab-scanner.c"
}


static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return self ? _gtk_tree_iter_dup (self) : NULL;
#line 1213 "baobab-scanner.c"
}


static void
baobab_scanner_ensure_iter_exists (BaobabScanner* self,
                                   BaobabScannerResults* results)
{
	GtkTreeIter* parent_iter = NULL;
	gboolean _tmp0_;
	BaobabScannerResults* _tmp1_;
	GtkTreeIter* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkTreeIter _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	guint64 _tmp11_;
#line 277 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 277 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (results != NULL);
#line 280 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = results->iter_is_set;
#line 280 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (_tmp0_) {
#line 281 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_free0 (parent_iter);
#line 281 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return;
#line 1242 "baobab-scanner.c"
	}
#line 284 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_ = results->parent;
#line 284 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (_tmp1_ != NULL) {
#line 1248 "baobab-scanner.c"
		BaobabScannerResults* _tmp2_;
		BaobabScannerResults* _tmp3_;
		GtkTreeIter _tmp4_;
		GtkTreeIter* _tmp5_;
#line 285 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp2_ = results->parent;
#line 285 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		baobab_scanner_ensure_iter_exists (self, _tmp2_);
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp3_ = results->parent;
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp4_ = _tmp3_->iter;
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp5_ = __gtk_tree_iter_dup0 (&_tmp4_);
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_free0 (parent_iter);
#line 286 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		parent_iter = _tmp5_;
#line 1267 "baobab-scanner.c"
	} else {
#line 288 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_free0 (parent_iter);
#line 288 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		parent_iter = NULL;
#line 1273 "baobab-scanner.c"
	}
#line 291 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp6_ = parent_iter;
#line 291 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	gtk_tree_store_append ((GtkTreeStore*) self, &_tmp7_, _tmp6_);
#line 291 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	results->iter = _tmp7_;
#line 292 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp8_ = results->iter;
#line 292 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp9_ = results->display_name;
#line 292 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp10_ = results->parse_name;
#line 292 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp11_ = results->time_modified;
#line 292 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	gtk_tree_store_set ((GtkTreeStore*) self, &_tmp8_, BAOBAB_SCANNER_COLUMNS_STATE, BAOBAB_SCANNER_STATE_SCANNING, BAOBAB_SCANNER_COLUMNS_DISPLAY_NAME, _tmp9_, BAOBAB_SCANNER_COLUMNS_PARSE_NAME, _tmp10_, BAOBAB_SCANNER_COLUMNS_TIME_MODIFIED, _tmp11_, -1);
#line 297 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	results->iter_is_set = TRUE;
#line 277 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_free0 (parent_iter);
#line 1295 "baobab-scanner.c"
}


static gboolean
baobab_scanner_process_results (BaobabScanner* self)
{
	gboolean result = FALSE;
	BaobabScanner* _tmp41_;
#line 300 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 301 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	while (TRUE) {
#line 1308 "baobab-scanner.c"
		BaobabScannerResultsArray* results_array = NULL;
		GAsyncQueue* _tmp0_;
		gpointer _tmp1_;
		BaobabScannerResultsArray* _tmp2_;
		BaobabScannerResultsArray* _tmp3_;
		BaobabScannerResults** _tmp4_;
		gint _tmp4__length1;
#line 302 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp0_ = self->priv->results_queue;
#line 302 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp1_ = g_async_queue_try_pop (_tmp0_);
#line 302 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		results_array = (BaobabScannerResultsArray*) _tmp1_;
#line 304 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp2_ = results_array;
#line 304 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		if (_tmp2_ == NULL) {
#line 305 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			_baobab_scanner_results_array_free0 (results_array);
#line 305 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			break;
#line 1330 "baobab-scanner.c"
		}
#line 308 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp3_ = results_array;
#line 308 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp4_ = _tmp3_->results;
#line 308 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp4__length1 = _tmp3_->results_length1;
#line 1338 "baobab-scanner.c"
		{
			BaobabScannerResults** results_collection = NULL;
			gint results_collection_length1 = 0;
			gint _results_collection_size_ = 0;
			gint results_it = 0;
#line 308 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			results_collection = _tmp4_;
#line 308 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			results_collection_length1 = _tmp4__length1;
#line 308 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			for (results_it = 0; results_it < _tmp4__length1; results_it = results_it + 1) {
#line 1350 "baobab-scanner.c"
				BaobabScannerResults* results = NULL;
#line 308 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				results = results_collection[results_it];
#line 1354 "baobab-scanner.c"
				{
					BaobabScannerResults* _tmp5_;
					BaobabScannerState state = 0;
					BaobabScannerResults* _tmp6_;
					gboolean _tmp7_;
					BaobabScannerResults* _tmp10_;
					GtkTreeIter _tmp11_;
					BaobabScannerResults* _tmp12_;
					guint64 _tmp13_;
					BaobabScannerResults* _tmp14_;
					guint64 _tmp15_;
					BaobabScannerResults* _tmp16_;
					gdouble _tmp17_;
					BaobabScannerResults* _tmp18_;
					gint _tmp19_;
					BaobabScannerState _tmp20_;
					BaobabScannerResults* _tmp21_;
					GError* _tmp22_;
					BaobabScannerResults* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					BaobabScannerResults* _tmp28_;
					GError* _tmp29_;
					BaobabScannerResults* _tmp39_;
					BaobabScannerResults* _tmp40_;
#line 309 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp5_ = results;
#line 309 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					baobab_scanner_ensure_iter_exists (self, _tmp5_);
#line 312 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp6_ = results;
#line 312 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp7_ = _tmp6_->child_error;
#line 312 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (_tmp7_) {
#line 313 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						state = BAOBAB_SCANNER_STATE_CHILD_ERROR;
#line 1392 "baobab-scanner.c"
					} else {
						BaobabScannerResults* _tmp8_;
						GError* _tmp9_;
#line 314 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp8_ = results;
#line 314 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp9_ = _tmp8_->error;
#line 314 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						if (_tmp9_ != NULL) {
#line 315 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							state = BAOBAB_SCANNER_STATE_ERROR;
#line 1404 "baobab-scanner.c"
						} else {
#line 317 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							state = BAOBAB_SCANNER_STATE_DONE;
#line 1408 "baobab-scanner.c"
						}
					}
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp10_ = results;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp11_ = _tmp10_->iter;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp12_ = results;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp13_ = _tmp12_->size;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp14_ = results;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp15_ = _tmp14_->alloc_size;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp16_ = results;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp17_ = _tmp16_->percent;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp18_ = results;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp19_ = _tmp18_->elements;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp20_ = state;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp21_ = results;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp22_ = _tmp21_->error;
#line 320 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					gtk_tree_store_set ((GtkTreeStore*) self, &_tmp11_, BAOBAB_SCANNER_COLUMNS_SIZE, _tmp13_, BAOBAB_SCANNER_COLUMNS_ALLOC_SIZE, _tmp15_, BAOBAB_SCANNER_COLUMNS_PERCENT, _tmp17_, BAOBAB_SCANNER_COLUMNS_ELEMENTS, _tmp19_, BAOBAB_SCANNER_COLUMNS_STATE, _tmp20_, BAOBAB_SCANNER_COLUMNS_ERROR, _tmp22_, -1);
#line 328 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp23_ = results;
#line 328 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp24_ = _tmp23_->max_depth;
#line 328 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp25_ = self->priv->_max_depth;
#line 328 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (_tmp24_ > _tmp25_) {
#line 1447 "baobab-scanner.c"
						BaobabScannerResults* _tmp26_;
						gint _tmp27_;
#line 329 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp26_ = results;
#line 329 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp27_ = _tmp26_->max_depth;
#line 329 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						baobab_scanner_set_max_depth (self, _tmp27_);
#line 1456 "baobab-scanner.c"
					}
#line 336 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp28_ = results;
#line 336 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp29_ = _tmp28_->error;
#line 336 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (_tmp29_ != NULL) {
#line 1464 "baobab-scanner.c"
						BaobabScannerResults* _tmp30_;
						GError* _tmp31_;
#line 337 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp30_ = results;
#line 337 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_tmp31_ = _tmp30_->error;
#line 337 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						if (g_error_matches (_tmp31_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 1473 "baobab-scanner.c"
							BaobabScannerResults* _tmp32_;
							GError* _tmp33_;
							GError* _tmp34_;
#line 338 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp32_ = results;
#line 338 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp33_ = _tmp32_->error;
#line 338 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp34_ = _g_error_copy0 (_tmp33_);
#line 338 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_g_error_free0 (self->priv->scan_error);
#line 338 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							self->priv->scan_error = _tmp34_;
#line 339 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 340 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							result = FALSE;
#line 340 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_baobab_scanner_results_array_free0 (results_array);
#line 340 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							return result;
#line 1495 "baobab-scanner.c"
						} else {
							GError* _tmp35_;
#line 341 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							_tmp35_ = self->priv->scan_error;
#line 341 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
							if (_tmp35_ == NULL) {
#line 1502 "baobab-scanner.c"
								BaobabScannerResults* _tmp36_;
								GError* _tmp37_;
								GError* _tmp38_;
#line 342 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
								_tmp36_ = results;
#line 342 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
								_tmp37_ = _tmp36_->error;
#line 342 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
								_tmp38_ = _g_error_copy0 (_tmp37_);
#line 342 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
								_g_error_free0 (self->priv->scan_error);
#line 342 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
								self->priv->scan_error = _tmp38_;
#line 1516 "baobab-scanner.c"
							}
						}
					}
#line 346 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp39_ = results;
#line 346 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp40_ = _tmp39_->parent;
#line 346 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					if (_tmp40_ == NULL) {
#line 347 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						self->priv->successful = TRUE;
#line 348 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 349 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						result = FALSE;
#line 349 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						_baobab_scanner_results_array_free0 (results_array);
#line 349 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
						return result;
#line 1536 "baobab-scanner.c"
					}
				}
			}
		}
#line 301 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 1543 "baobab-scanner.c"
	}
#line 354 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp41_ = self->priv->self;
#line 354 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	result = _tmp41_ != NULL;
#line 354 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 1551 "baobab-scanner.c"
}


static gpointer
_g_thread_ref0 (gpointer self)
{
#line 361 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return self ? g_thread_ref (self) : NULL;
#line 1560 "baobab-scanner.c"
}


static void
baobab_scanner_cancel_and_reset (BaobabScanner* self)
{
	GCancellable* _tmp0_;
	GThread* _tmp1_;
	guint _tmp4_;
	BaobabScannerResultsArray* tmp = NULL;
	GAsyncQueue* _tmp6_;
	gpointer _tmp7_;
	GCancellable* _tmp11_;
#line 357 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 358 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = self->priv->cancellable;
#line 358 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_cancellable_cancel (_tmp0_);
#line 360 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_ = self->priv->thread;
#line 360 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (_tmp1_ != NULL) {
#line 1584 "baobab-scanner.c"
		GThread* _tmp2_;
		GThread* _tmp3_;
#line 361 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp2_ = self->priv->thread;
#line 361 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp3_ = _g_thread_ref0 (_tmp2_);
#line 361 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_thread_join (_tmp3_);
#line 362 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_thread_unref0 (self->priv->thread);
#line 362 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->thread = NULL;
#line 1597 "baobab-scanner.c"
	}
#line 365 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp4_ = self->priv->process_result_idle;
#line 365 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (_tmp4_ != ((guint) 0)) {
#line 1603 "baobab-scanner.c"
		guint _tmp5_;
#line 366 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp5_ = self->priv->process_result_idle;
#line 366 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_source_remove (_tmp5_);
#line 367 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->process_result_idle = (guint) 0;
#line 1611 "baobab-scanner.c"
	}
#line 371 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp6_ = self->priv->results_queue;
#line 371 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp7_ = g_async_queue_try_pop (_tmp6_);
#line 371 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	tmp = (BaobabScannerResultsArray*) _tmp7_;
#line 372 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	while (TRUE) {
#line 1621 "baobab-scanner.c"
		BaobabScannerResultsArray* _tmp8_;
		GAsyncQueue* _tmp9_;
		gpointer _tmp10_;
#line 372 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp8_ = tmp;
#line 372 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		if (!(_tmp8_ != NULL)) {
#line 372 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			break;
#line 1631 "baobab-scanner.c"
		}
#line 373 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp9_ = self->priv->results_queue;
#line 373 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp10_ = g_async_queue_try_pop (_tmp9_);
#line 373 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (tmp);
#line 373 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		tmp = (BaobabScannerResultsArray*) _tmp10_;
#line 1641 "baobab-scanner.c"
	}
#line 376 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->hardlinks = (g_free (self->priv->hardlinks), NULL);
#line 376 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->hardlinks = NULL;
#line 376 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->hardlinks_length1 = 0;
#line 376 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->_hardlinks_size_ = self->priv->hardlinks_length1;
#line 378 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	gtk_tree_store_clear (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_store_get_type (), GtkTreeStore));
#line 380 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp11_ = self->priv->cancellable;
#line 380 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_cancellable_reset (_tmp11_);
#line 381 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 381 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->scan_error = NULL;
#line 357 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_baobab_scanner_results_array_free0 (tmp);
#line 1663 "baobab-scanner.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 393 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return self ? g_object_ref (self) : NULL;
#line 1672 "baobab-scanner.c"
}


static gpointer
_baobab_scanner_scan_in_thread_gthread_func (gpointer self)
{
	gpointer result;
	result = baobab_scanner_scan_in_thread ((BaobabScanner*) self);
#line 395 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_object_unref (self);
#line 395 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 1685 "baobab-scanner.c"
}


static gboolean
___lambda4_ (BaobabScanner* self)
{
	gboolean result = FALSE;
	gboolean res = FALSE;
	gboolean _tmp0_;
#line 398 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	res = baobab_scanner_process_results (self);
#line 399 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = res;
#line 399 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (!_tmp0_) {
#line 400 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->process_result_idle = (guint) 0;
#line 1703 "baobab-scanner.c"
	}
#line 402 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	result = res;
#line 402 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 1709 "baobab-scanner.c"
}


static gboolean
____lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda4_ ((BaobabScanner*) self);
#line 397 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 1720 "baobab-scanner.c"
}


void
baobab_scanner_scan (BaobabScanner* self,
                     gboolean force)
{
	gboolean _tmp0_;
#line 384 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 385 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (force) {
#line 386 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->successful = FALSE;
#line 1735 "baobab-scanner.c"
	}
#line 389 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = self->priv->successful;
#line 389 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (!_tmp0_) {
#line 1741 "baobab-scanner.c"
		BaobabScanner* _tmp1_;
		GThread* _tmp2_;
#line 390 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		baobab_scanner_cancel_and_reset (self);
#line 393 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp1_ = _g_object_ref0 (self);
#line 393 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->self);
#line 393 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->self = _tmp1_;
#line 395 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp2_ = g_thread_new ("scanner", _baobab_scanner_scan_in_thread_gthread_func, g_object_ref (self));
#line 395 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_thread_unref0 (self->priv->thread);
#line 395 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->thread = _tmp2_;
#line 397 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->process_result_idle = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 1760 "baobab-scanner.c"
	} else {
#line 405 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 1764 "baobab-scanner.c"
	}
}


void
baobab_scanner_cancel (BaobabScanner* self)
{
	gboolean _tmp0_;
#line 409 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 410 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = self->priv->successful;
#line 410 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (!_tmp0_) {
#line 411 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		baobab_scanner_cancel_and_reset (self);
#line 1781 "baobab-scanner.c"
	}
}


void
baobab_scanner_finish (BaobabScanner* self,
                       GError** error)
{
	GError* _tmp0_;
	GError * _inner_error_ = NULL;
#line 415 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 416 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = self->priv->scan_error;
#line 416 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (_tmp0_ != NULL) {
#line 1798 "baobab-scanner.c"
		GError* _tmp1_;
		GError* _tmp2_;
#line 417 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp1_ = self->priv->scan_error;
#line 417 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp2_ = _g_error_copy0 (_tmp1_);
#line 417 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_inner_error_ = _tmp2_;
#line 417 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_propagate_error (error, _inner_error_);
#line 417 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		return;
#line 1811 "baobab-scanner.c"
	}
}


static void
_g_unix_mount_free0_ (gpointer var)
{
#line 442 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(var == NULL) ? NULL : (var = (g_unix_mount_free (var), NULL));
#line 1821 "baobab-scanner.c"
}


static inline void
_g_list_free__g_unix_mount_free0_ (GList* self)
{
#line 442 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_list_free_full (self, (GDestroyNotify) _g_unix_mount_free0_);
#line 1830 "baobab-scanner.c"
}


static void
_baobab_scanner_results_array_free0_ (gpointer var)
{
#line 449 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(var == NULL) ? NULL : (var = (baobab_scanner_results_array_free (var), NULL));
#line 1839 "baobab-scanner.c"
}


BaobabScanner*
baobab_scanner_construct (GType object_type,
                          GFile* directory,
                          BaobabScanFlags flags)
{
	BaobabScanner * self = NULL;
	GCancellable* _tmp0_;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
	BaobabApplication* _tmp3_;
	BaobabApplication* _tmp4_;
	GHashTable* _tmp5_;
	GHashTable* _tmp11_;
	GAsyncQueue* _tmp12_;
#line 421 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 421 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self = (BaobabScanner*) g_object_new (object_type, NULL);
#line 422 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	baobab_scanner_set_directory (self, directory);
#line 423 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	baobab_scanner_set_scan_flags (self, flags);
#line 424 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = g_cancellable_new ();
#line 424 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 424 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->cancellable = _tmp0_;
#line 425 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 425 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->scan_error = NULL;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_ = g_new0 (GType, 9);
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[0] = G_TYPE_STRING;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[1] = G_TYPE_STRING;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[2] = G_TYPE_DOUBLE;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[3] = G_TYPE_UINT64;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[4] = G_TYPE_UINT64;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[5] = G_TYPE_UINT64;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[6] = G_TYPE_INT;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[7] = BAOBAB_SCANNER_TYPE_STATE;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp1_[8] = G_TYPE_ERROR;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp2_ = _tmp1_;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp2__length1 = 9;
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	gtk_tree_store_set_column_types ((GtkTreeStore*) self, 9, _tmp2_);
#line 426 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 437 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, (gint) BAOBAB_SCANNER_COLUMNS_SIZE, GTK_SORT_DESCENDING);
#line 439 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp3_ = baobab_application_get_default ();
#line 439 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp4_ = _tmp3_;
#line 439 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp5_ = baobab_application_get_excluded_locations (_tmp4_);
#line 439 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->excluded_locations);
#line 439 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->excluded_locations = _tmp5_;
#line 439 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_object_unref0 (_tmp4_);
#line 441 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if ((flags & BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS) == BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS) {
#line 1920 "baobab-scanner.c"
		GList* _tmp6_;
#line 442 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp6_ = g_unix_mounts_get (NULL);
#line 1924 "baobab-scanner.c"
		{
			GList* mount_collection = NULL;
			GList* mount_it = NULL;
#line 442 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			mount_collection = _tmp6_;
#line 442 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			for (mount_it = mount_collection; mount_it != NULL; mount_it = mount_it->next) {
#line 1932 "baobab-scanner.c"
				GUnixMountEntry* mount = NULL;
#line 442 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
				mount = (GUnixMountEntry*) mount_it->data;
#line 1936 "baobab-scanner.c"
				{
					GHashTable* _tmp7_;
					GUnixMountEntry* _tmp8_;
					const gchar* _tmp9_;
					GFile* _tmp10_;
#line 443 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp7_ = self->priv->excluded_locations;
#line 443 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp8_ = mount;
#line 443 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp9_ = g_unix_mount_get_mount_path (_tmp8_);
#line 443 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					_tmp10_ = g_file_new_for_path (_tmp9_);
#line 443 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
					g_hash_table_add (_tmp7_, _tmp10_);
#line 1952 "baobab-scanner.c"
				}
			}
#line 442 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
			(mount_collection == NULL) ? NULL : (mount_collection = (_g_list_free__g_unix_mount_free0_ (mount_collection), NULL));
#line 1957 "baobab-scanner.c"
		}
	}
#line 447 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp11_ = self->priv->excluded_locations;
#line 447 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_hash_table_remove (_tmp11_, directory);
#line 449 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp12_ = g_async_queue_new_full (_baobab_scanner_results_array_free0_);
#line 449 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_async_queue_unref0 (self->priv->results_queue);
#line 449 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->results_queue = _tmp12_;
#line 421 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return self;
#line 1972 "baobab-scanner.c"
}


BaobabScanner*
baobab_scanner_new (GFile* directory,
                    BaobabScanFlags flags)
{
#line 421 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return baobab_scanner_construct (BAOBAB_TYPE_SCANNER, directory, flags);
#line 1982 "baobab-scanner.c"
}


GFile*
baobab_scanner_get_directory (BaobabScanner* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = self->priv->_directory;
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	result = _tmp0_;
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 1999 "baobab-scanner.c"
}


static void
baobab_scanner_set_directory (BaobabScanner* self,
                              GFile* value)
{
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (baobab_scanner_get_directory (self) != value) {
#line 2011 "baobab-scanner.c"
		GFile* _tmp0_;
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->_directory);
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->_directory = _tmp0_;
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_DIRECTORY_PROPERTY]);
#line 2021 "baobab-scanner.c"
	}
}


BaobabScanFlags
baobab_scanner_get_scan_flags (BaobabScanner* self)
{
	BaobabScanFlags result;
	BaobabScanFlags _tmp0_;
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = self->priv->_scan_flags;
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	result = _tmp0_;
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 2039 "baobab-scanner.c"
}


static void
baobab_scanner_set_scan_flags (BaobabScanner* self,
                               BaobabScanFlags value)
{
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (baobab_scanner_get_scan_flags (self) != value) {
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->_scan_flags = value;
#line 56 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY]);
#line 2055 "baobab-scanner.c"
	}
}


gint
baobab_scanner_get_max_depth (BaobabScanner* self)
{
	gint result;
	gint _tmp0_;
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_tmp0_ = self->priv->_max_depth;
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	result = _tmp0_;
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return result;
#line 2073 "baobab-scanner.c"
}


void
baobab_scanner_set_max_depth (BaobabScanner* self,
                              gint value)
{
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	if (baobab_scanner_get_max_depth (self) != value) {
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		self->priv->_max_depth = value;
#line 58 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_MAX_DEPTH_PROPERTY]);
#line 2089 "baobab-scanner.c"
	}
}


static BaobabScannerResultsArray*
baobab_scanner_results_array_new (void)
{
	BaobabScannerResultsArray* self;
#line 134 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self = g_slice_new0 (BaobabScannerResultsArray);
#line 134 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	baobab_scanner_results_array_instance_init (self);
#line 134 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return self;
#line 2104 "baobab-scanner.c"
}


static void
baobab_scanner_results_array_instance_init (BaobabScannerResultsArray * self)
{
}


static void
baobab_scanner_results_array_free (BaobabScannerResultsArray * self)
{
#line 135 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->results = (_vala_array_free (self->results, self->results_length1, (GDestroyNotify) baobab_scanner_results_free), NULL);
#line 134 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_slice_free (BaobabScannerResultsArray, self);
#line 2121 "baobab-scanner.c"
}


static BaobabScannerResults*
baobab_scanner_results_new (void)
{
	BaobabScannerResults* self;
#line 139 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self = g_slice_new0 (BaobabScannerResults);
#line 139 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	baobab_scanner_results_instance_init (self);
#line 139 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return self;
#line 2135 "baobab-scanner.c"
}


static void
baobab_scanner_results_instance_init (BaobabScannerResults * self)
{
}


static void
baobab_scanner_results_free (BaobabScannerResults * self)
{
#line 143 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_free0 (self->display_name);
#line 144 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_free0 (self->parse_name);
#line 154 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_error_free0 (self->error);
#line 139 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_slice_free (BaobabScannerResults, self);
#line 2156 "baobab-scanner.c"
}


static void
baobab_scanner_hard_link_init (BaobabScannerHardLink *self,
                               GFileInfo* info)
{
#line 78 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_return_if_fail (info != NULL);
#line 78 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	memset (self, 0, sizeof (BaobabScannerHardLink));
#line 79 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(*self).inode = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_UNIX_INODE);
#line 80 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	(*self).device = g_file_info_get_attribute_uint32 (info, G_FILE_ATTRIBUTE_UNIX_DEVICE);
#line 2172 "baobab-scanner.c"
}


static BaobabScannerHardLink*
baobab_scanner_hard_link_dup (const BaobabScannerHardLink* self)
{
	BaobabScannerHardLink* dup;
#line 74 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	dup = g_new0 (BaobabScannerHardLink, 1);
#line 74 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	memcpy (dup, self, sizeof (BaobabScannerHardLink));
#line 74 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	return dup;
#line 2186 "baobab-scanner.c"
}


static void
baobab_scanner_hard_link_free (BaobabScannerHardLink* self)
{
#line 74 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_free (self);
#line 2195 "baobab-scanner.c"
}


static GType
baobab_scanner_hard_link_get_type (void)
{
	static volatile gsize baobab_scanner_hard_link_type_id__volatile = 0;
	if (g_once_init_enter (&baobab_scanner_hard_link_type_id__volatile)) {
		GType baobab_scanner_hard_link_type_id;
		baobab_scanner_hard_link_type_id = g_boxed_type_register_static ("BaobabScannerHardLink", (GBoxedCopyFunc) baobab_scanner_hard_link_dup, (GBoxedFreeFunc) baobab_scanner_hard_link_free);
		g_once_init_leave (&baobab_scanner_hard_link_type_id__volatile, baobab_scanner_hard_link_type_id);
	}
	return baobab_scanner_hard_link_type_id__volatile;
}


static void
baobab_scanner_class_init (BaobabScannerClass * klass)
{
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	baobab_scanner_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_type_class_add_private (klass, sizeof (BaobabScannerPrivate));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_baobab_scanner_get_property;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_baobab_scanner_set_property;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_scanner_finalize;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_DIRECTORY_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_DIRECTORY_PROPERTY] = g_param_spec_object ("directory", "directory", "directory", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY] = g_param_spec_flags ("scan-flags", "scan-flags", "scan-flags", BAOBAB_TYPE_SCAN_FLAGS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_MAX_DEPTH_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_MAX_DEPTH_PROPERTY] = g_param_spec_int ("max-depth", "max-depth", "max-depth", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL] = g_signal_new ("completed", BAOBAB_TYPE_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2233 "baobab-scanner.c"
}


static void
baobab_scanner_instance_init (BaobabScanner * self)
{
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv = BAOBAB_SCANNER_GET_PRIVATE (self);
#line 84 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->thread = NULL;
#line 85 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->process_result_idle = (guint) 0;
#line 90 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->successful = FALSE;
#line 2248 "baobab-scanner.c"
}


static void
baobab_scanner_finalize (GObject * obj)
{
	BaobabScanner * self;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 54 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->_directory);
#line 84 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_thread_unref0 (self->priv->thread);
#line 87 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	self->priv->hardlinks = (g_free (self->priv->hardlinks), NULL);
#line 88 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->excluded_locations);
#line 128 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_async_queue_unref0 (self->priv->results_queue);
#line 129 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->self);
#line 130 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 131 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	G_OBJECT_CLASS (baobab_scanner_parent_class)->finalize (obj);
#line 2276 "baobab-scanner.c"
}


GType
baobab_scanner_get_type (void)
{
	static volatile gsize baobab_scanner_type_id__volatile = 0;
	if (g_once_init_enter (&baobab_scanner_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BaobabScannerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_scanner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabScanner), 0, (GInstanceInitFunc) baobab_scanner_instance_init, NULL };
		GType baobab_scanner_type_id;
		baobab_scanner_type_id = g_type_register_static (gtk_tree_store_get_type (), "BaobabScanner", &g_define_type_info, 0);
		g_once_init_leave (&baobab_scanner_type_id__volatile, baobab_scanner_type_id);
	}
	return baobab_scanner_type_id__volatile;
}


static void
_vala_baobab_scanner_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	BaobabScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		case BAOBAB_SCANNER_DIRECTORY_PROPERTY:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_value_set_object (value, baobab_scanner_get_directory (self));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_value_set_flags (value, baobab_scanner_get_scan_flags (self));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		case BAOBAB_SCANNER_MAX_DEPTH_PROPERTY:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		g_value_set_int (value, baobab_scanner_get_max_depth (self));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 2322 "baobab-scanner.c"
		default:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 2328 "baobab-scanner.c"
	}
}


static void
_vala_baobab_scanner_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	BaobabScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		case BAOBAB_SCANNER_DIRECTORY_PROPERTY:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		baobab_scanner_set_directory (self, g_value_get_object (value));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		baobab_scanner_set_scan_flags (self, g_value_get_flags (value));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		case BAOBAB_SCANNER_MAX_DEPTH_PROPERTY:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		baobab_scanner_set_max_depth (self, g_value_get_int (value));
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 2361 "baobab-scanner.c"
		default:
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/baobab-3.28.0/src/baobab-scanner.vala"
		break;
#line 2367 "baobab-scanner.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



